using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Treci_Zadatak
{
    class Vodopad
    {
        int h, n;
        int[,] TerenVodopada;
        int[] Voda;
        public Vodopad()
        {
            string[] temp = Console.ReadLine().Split(' ');
            h = Convert.ToInt32(temp[0]);
            n = Convert.ToInt32(temp[1]);
            TerenVodopada= new Int32[h, n];
            Voda = new int[n];
            for (int i = 0; i < h; i++)
            {
                temp = Console.ReadLine().Split(' ');
                for (int j = 0; j < n; j++)
                {
                    TerenVodopada[i, j] = Convert.ToInt32(temp[j]);
                }
            }
            for (int i = 0; i < n; i++) Voda[i] = 1;
        }
        public void Rezultat()
        {
            for (int i = 0; i < h; i++)
            {
                Spust(i);
            }
        }
        private void Spust(int k)
        {
            for (int i = 0; i < n; i++)
            {
                if (TerenVodopada[k, i] == 0 && Voda[i] != 0)
                {
                    Levo(Voda[i] / 2 + ((Voda[i] % 2 == 1 && k % 2 == 0) ? 1 : 0),k,i);
                    Desno(Voda[i] / 2 + ((Voda[i] % 2 == 1 && k % 2 == 1) ? 1 : 0),k,i);
                    Voda[i] = 0;
                }
            }
        }
        private void Levo(int vrednost,int a,int b)
        {
            int temp = 0;
            if (vrednost == 0) return;
            while (TerenVodopada[a,b-temp]!=1)
            {
                if (b == 0) { Desno(vrednost, a, b - temp); return; }
                temp++;
            }
            Voda[b - temp]+=vrednost;
            return;
        }
        private void Desno(int vrednost, int a, int b)
        {
            int temp = 0;
            if (vrednost == 0) return;
            while (TerenVodopada[a, b + temp] != 1)
            {
                if (b == n-1) { Levo(vrednost, a, b + temp);return; }
                temp++;
            }
            Voda[b + temp] += vrednost;
            return;
        }
        public void Ispis()
        {
            for (int i = 0; i < n; i++)
            {
                Console.Write(Voda[i]+" ");
            }
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Vodopad VodopadGostiljski = new Vodopad();
            VodopadGostiljski.Rezultat();
            VodopadGostiljski.Ispis();
        }
    }
}